{----------------- Elvis Sprite -----------------}

 Procedure DspElvSprites; Begin End;

 Procedure DspDtaSprites;
  Var Colonne, Ligne, Col,Lig,n, Mask : Byte;
      Adr:Integer;
  Begin

    AfficheCadre;

    { Affiche Big  Sprite depuis EvlSprites }
    For Col:=1 To ElvBigSprL.Taille Do Begin
      For Lig:=1 To ElvBigSprH.Taille Do Begin
        n:=Col+(Lig-1)*ElvBigSprL.Taille;
        With ElvSprites Do Begin
          For Colonne:=$0 To $f Do Begin
            xs:=2+2*Colonne+32*(Col-1);
            For Ligne:=$0 To $f Do Begin
              ys:=4*(Ligne+1)+64*(Lig-1);
              e:=BmpSpr[n,NumImg]^[Ligne,Colonne];
              SetSprPxl(n,Ligne,Colonne,e);
              GetPntAdr(xs,199-ys,Adr,Mask);
              DrwFldBox(EncInk(TColor(e)),Adr,1,4);
            End;
          End;
        End;
      End;
    End;
  End;

 { Edition des sprites }

  Procedure EdtDtaSprites;
    Var c,cc:Char;
        xc,yc,xm,ym:Integer;
        AncienneCouleur,NouvelleCouleur,Ligne,Colonne : Byte;

   { Debut des sous-procedures de EdtDtaSprites -> }

    Procedure ChgCouleur;
     Begin
       DrwPxl(Ligne,Colonne,ElvPal.NumPal);
     End;

    Procedure GetCouleur;
     Begin
       ElvPal.NumPal:=GetBigSprPxl(1,Ligne,Colonne);
       If ElvBord.On Then SetPalBdr(ElvPal.Pal[ElvPal.NumPal]) Else SetPalBdr($bbb);
       DspDtaPal; DspDtaVrb;
     End;

    Procedure Marque;
     Begin
       GetCurXY(xc,yc); GetCurColLig(ColM, LigM);
       MovSpr(SprMarque,xc,yc);
       SetZoomSpr(SprMarque,Zx2+Zy1);
     End;

    Procedure TraceDroite;
     Var xw,ym:Integer;
     Begin
       DrwSpdLin(LigM,ColM,Ligne,Colonne,ElvPal.NumPal);
       GetCurXY(xm,ym);
       LigM:=Ligne; ColM:=Colonne;
       MovSpr(SprMarque,xm,ym);
     End;

    Procedure Rectangle(L1,C1,L2,C2,c:Byte; Plein:Boolean);
     Var h,h1,h2:Byte;
     Begin
       If L1>L2 Then Begin h1:=L2; h2:=L1 End Else Begin h1:=L1; h2:=L2; End;
       If Plein Then Begin
         For h:=h1 To h2 Do DrwSpdLin(h,C1,h,C2,c);
       End Else Begin
         DrwSpdLin( L1, C1 , L1 , C2  ,ElvPal.NumPal);
         DrwSpdLin( L2, C1 , L2 , C2  ,ElvPal.NumPal);
         DrwSpdLin( L1, C1 , L2 , C1  ,ElvPal.NumPal);
         DrwSpdLin( L1, C2 , L2 , C2  ,ElvPal.NumPal);
       End;
     End;

    {$A-} { procedure recursive  !! A ameliorer !! }
    Procedure Fill(Ligne,Colonne:Byte);
      Begin
        ProfRecursion:=ProfRecursion+1;
        If ProfRecursion<400 Then Begin
          If GetBigSprPxl(1,Ligne,Colonne)=AncienneCouleur Then Begin
            DrwPxl(Ligne,Colonne,NouvelleCouleur);
            If Ligne<16*ElvBigSprH.Taille-1   Then Fill(Ligne+1, Colonne  );
            If Ligne>0                        Then Fill(Ligne-1, Colonne  );
            If Colonne<16*ElvBigSprl.Taille-1 Then Fill(Ligne  , Colonne+1);
            If Colonne>0                      Then Fill(Ligne  , Colonne-1);
          End;
        End;
        ProfRecursion:=ProfRecursion-1;
       End;
    {$A+}

    Procedure Cercle(xc,yc,Rayon:Integer; Couleur:Byte; Plein:Boolean);
      Var x,y,d : Integer;
      Begin
        x:=0;
        y:=Rayon;
        d:=Rayon;
        While y>=x Do Begin
          If Plein Then Begin
            DrwSpdLin(xc-x,yc-y,xc+x,yc-y,ElvPal.NumPal);
            DrwSpdLin(xc-y,yc-x,xc+y,yc-x,ElvPal.NumPal);
            DrwSpdLin(xc-x,yc+y,xc+x,yc+y,ElvPal.NumPal);
            DrwSpdLin(xc-y,yc+x,xc+y,yc+x,ElvPal.NumPal);
          End Else Begin
            DrwPxl(xc+x,yc+y,Couleur);
            DrwPxl(xc+y,yc+x,Couleur);
            DrwPxl(xc-x,yc+y,Couleur);
            DrwPxl(xc-y,yc+x,Couleur);
            DrwPxl(xc+x,yc-y,Couleur);
            DrwPxl(xc+y,yc-x,Couleur);
            DrwPxl(xc-x,yc-y,Couleur);
            DrwPxl(xc-y,yc-x,Couleur);
          End;
          If d>=2*x Then Begin
            d:=d-2*x-1;
            x:=x+1;
          End Else If d<2*(Rayon-y) Then Begin
            d:=d+2*y-1;
            y:=y-1;
          End Else Begin
            d:=d+2*(y-x-1);
            y:=y-1;
            x:=x+1;
          End;
        End;
      End;

   Procedure DecaleDroite;
    Var c,l:Byte;
    Begin
      For l:=0 To ElvBigSprH.Taille*16-1 Do
        For c:=ElvBigSprL.Taille*16-2 DownTo 0 Do Begin
          DrwPxl(l,c+1,GetBigSprPxl(1,l,c));
        End;
    End;

   Procedure DecaleGauche;
    Var c,l:Byte;
    Begin
      For l:=0 To ElvBigSprH.Taille*16-1 Do
        For c:=1 To ElvBigSprL.Taille*16-1 Do Begin
          DrwPxl(l,c-1,GetBigSprPxl(1,l,c));
        End;
    End;

   Procedure DecaleHaut;
    Var i,j,k:Byte;
        Adr:Integer;
    Begin
      For i:=1 To ElvBigSprH.Taille Do Begin
        For j:=1 To ElvBigSprL.Taille Do
          With ElvSprites Do Begin
            k:=j+(i-1)*ElvBigSprL.Taille;
            Move(BmpSpr[k,NumImg]^[1,0], BmpSpr[k,NumImg]^[0,0], 15*16);
            If i<ElvBigSprH.Taille Then
              Move(BmpSpr[j+i*ElvBigSprL.Taille,NumImg]^[0,0],BmpSpr[k,NumImg]^[15,0],16)
            Else
              FillChar(BmpSpr[k,NumImg]^[15,0],16,0)
          End;
      End;
      CpyWin( 3, 195-4, ElvBigSprL.Taille*16, ElvBigSprH.Taille*64-4, 3, 195);
      DrwSpdLin(ElvBigSprH.Taille*16-1, 0,
                ElvBigSprH.Taille*16-1, ElvBigSprL.Taille*16-1, 0);

      j:=ElvBigSprL.Taille*ElvBigSprH.Taille;
      For i:=1 To j Do  CpySprToAsic(ElvSprites.BmpSpr[i,NumImg]^,i);
    End;

   Procedure DecaleBas;
    Var i,j,k:Byte;
        Win:TPWin;
    Begin
      For i:= ElvBigSprH.Taille DownTo 1 Do Begin
        For j:=1 To ElvBigSprL.Taille Do
          With ElvSprites Do Begin
            k:=j+(i-1)*ElvBigSprL.Taille;
            Move(BmpSpr[k,NumImg]^[0,0], BmpSpr[k,NumImg]^[1,0], 15*16);
            If i>1 Then
              Move(BmpSpr[j+(i-2)*ElvBigSprL.Taille,NumImg]^[15,0],BmpSpr[k,NumImg]^[0,0],16)
            Else
              FillChar(BmpSpr[k,NumImg]^[0,0],16,0)
          End;
      End;

      Win:=GetWin(3,195, ElvBigSprL.Taille*16, ElvBigSprH.Taille*64-4);
      PutWin(3,191, Win); DisposeWin(Win);

      DrwSpdLin(0, 0, 0, ElvBigSprL.Taille*16-1, 0);

      j:=ElvBigSprL.Taille*ElvBigSprH.Taille;
      For i:=1 To j Do  CpySprToAsic(ElvSprites.BmpSpr[i,NumImg]^,i);

     End;

   Procedure HautVersBas;
     Var i,j,k,m : Byte;
         Temp: Array[0..$f] Of Byte;
     Begin
       j:=ElvBigSprH.Taille*16-1;
       k:=ElvBigSprL.Taille;

       For i:=0 To j Div 2 Do Begin
         For m:=1 To k Do Begin
           With ElvSprites Do Begin
             Move(BmpSpr[(i Div 16)+m, NumImg]^[i Mod 16,0],Temp,$10);
             Move(BmpSpr[k*((j-i) Div 16)+m, NumImg]^[(j-i) Mod 16 ,0],BmpSpr[i Div 16+m,NumImg]^[i Mod 16,0],$10);
             Move(Temp,BmpSpr[k*((j-i) Div 16)+m, NumImg]^[(j-i) Mod 16 ,0],$10);
           End;
         End;
       End;
       DspDtaSprites;
     End;

   Procedure DroiteGauche;
    Var c,l,Temp:Byte;
    Begin
      For l:=0 To ElvBigSprH.Taille*16-1 Do
        For c:=0 To (ElvBigSprL.Taille*16-1) Div 2 Do Begin
          Temp:=GetBigSprPxl(1,l,c);
          DrwPxl(l, c, GetBigSprPxl(1,l,ElvBigSprL.Taille*16-1-c));
          DrwPxl(l, ElvBigSprL.Taille*16-1-c,Temp);
        End;
    End;

   Procedure AffReticule;
      Var xc,yc:Integer;
      Begin
       GetCurXY(xc,yc);xc:=xc+6;yc:=392-yc*2;
       SetWrtMod(XorMode); SetGraPen(1);

       { Affiche }
       MovAbs(4,yc);   DrwLinRel(4+ElvBigSprL.Taille*128,0);
       MovAbs(xc,392); DrwLinRel(0,-2-ElvBigSprH.Taille*128);

       Repeat Until Not(TstKey(12));

       { Efface }
       MovAbs(4,yc);   DrwLinRel(4+ElvBigSprL.Taille*128,0);
       MovAbs(xc,392); DrwLinRel(0,-2-ElvBigSprH.Taille*128);

       SetWrtMod(ForceMode);
      End;

    Procedure AffReticuleDiag;
      Var xc,yc:Integer;
      Begin
       GetCurXY(xc,yc);xc:=xc+6;yc:=392-yc*2;
       SetWrtMod(XorMode); SetGraPen(1);

       { Affiche }
       MovAbs(xc,yc); DrwLinRel(400,400);  MovAbs(xc,yc); DrwLinRel(-400,-400);
       MovAbs(xc,yc); DrwLinRel(-400,400); MovAbs(xc,yc); DrwLinRel(400,-400);

       Repeat Until Not(TstKey(13));

       { Efface }
       MovAbs(xc,yc); DrwLinRel(400,400); MovAbs(xc,yc); DrwLinRel(-400,-400);
       MovAbs(xc,yc); DrwLinRel(-400,400);MovAbs(xc,yc); DrwLinRel(400,-400);
       SetWrtMod(ForceMode);
      End;

    Procedure Copier; { Copier bloc image }
      Var CCopie1, CCopie2, LCopie1, LCopie2, c, l: Byte;
          Hauteur,Largeur,xc,yc: Integer;
      Begin

        { Raz ancienne copie }
        If SizCopie>2  Then Begin
          FreeMem(SprCopie,SizCopie);
          SizCopie:=0;
        End;

        { Nouvelle copie }
        LCopie1:=LigM; LCopie2:=Ligne;
        If LCopie2<LCopie1 Then Begin LCopie1:=Ligne; LCopie2:=LigM; End;

        CCopie1:=ColM; CCopie2:=Colonne;
        If CCopie2<CCopie1 Then Begin CCopie1:=Colonne; CCopie2:=ColM; End;

        Hauteur:=LCopie2-LCopie1+1;
        Largeur:=CCopie2-CCopie1+1;

        SizCopie:=2+Hauteur*Largeur;
        If SizCopie>2 Then Begin
          { Affiche }
          GetCurXY(xc,yc);xc:=xc+6;yc:=392-yc*2;
          GetSprPos(SprMarque,xm,ym); xm:=xm+6; ym:=392-ym*2;
          SetWrtMod(XorMode); SetGraPen(1);
          MovAbs(xc,yc); DrwRecRel((xm-xc),(ym-yc));

          GetMem(SprCopie,SizCopie);
          SprCopie^[0]:=Largeur;
          SprCopie^[1]:=Hauteur;
          For c:=CCopie1 To CCopie2 Do
            For l:=LCopie1 To LCopie2 Do
              SprCopie^[2+(c-CCopie1)+(l-LCopie1)*Largeur]:=GetBigSprPxl(1,l,c);

         { Efface }
          MovAbs(xc,yc); DrwRecRel((xm-xc),(ym-yc));
          SetWrtMod(ForceMode);

        End;
      End;

    Procedure Coller;
      Var c,l:Byte;
      Begin
        If SizCopie<3  Then
          PopUp('Pas d''image @ copier')
        Else Begin { Coller }
          For l:=Ligne To Ligne+SprCopie^[1]-1 Do
            For c:=Colonne To Colonne+SprCopie^[0]-1 Do
              DrwPxl(l,c,SprCopie^[2+(c-Colonne)+(l-Ligne)*SprCopie^[0]]);
        End;
      End;

   { Fin des sous-procedures de EdtDtaSprites <- }

    Begin { EdtDtaSprites }

      SetZoomSpr(SprCurseur,Zx2+Zy1);

      If NumImg<>ElVVAnim.vCycle Then Begin
          SetGraPen(0); DspDtaVAnim;
          NumImg:=ElvVAnim.vCycle;
          SetGraPen(15); DspDtaVAnim;
          DspDtaSprites;
      End;

      Repeat

        cc:=GetChr;
        GetMousePos; GetMouseXY(Xm,Ym);
        GetCurColLig(Colonne,Ligne);

        Case cc Of
          'X'  : Begin { Clic Souris }
                   SetCurFromMouse(Xm,Ym);
                   If Not(MouseInRec(0,0,12+ElvBigSprL.Taille*8*16,4+398-ElvBigSprH.Taille*4*16))
                   Then cc:=KeyEsc;
                 End;

          CtrlLeftArrow : SetCurColLig(0,Ligne);
          CtrlRightArrow: SetCurColLig(16*ElvBigSprL.Taille-1,Ligne);
          CtrlUpArrow   : SetCurColLig(Colonne,0);
          CtrlDownArrow : SetCurColLig(Colonne,16*ElvBigSprH.Taille-1);

          LeftArrow : If Colonne>0 Then MovCurColLig(-1, 0);
          RightArrow: If Colonne<16*ElvBigSprL.Taille-1 Then MovCurColLig( 1, 0);
          UpArrow   : If Ligne>0 Then MovCurColLig( 0,-1);
          DownArrow : If Ligne<16*ElvBigSprH.Taille-1 Then MovCurColLig( 0, 1);

          ShiftRightArrow : If Colonne<16*ElvBigSprL.Taille-1 Then Begin ChgCouleur; MovCurColLig( 1, 0); End;
          ShiftLeftArrow  : If Colonne>0                      Then Begin ChgCouleur; MovCurColLig(-1, 0); End;
          ShiftDownArrow  : If Ligne>0                        Then Begin ChgCouleur; MovCurColLig( 0,-1); End;
          ShiftUpArrow    : If Ligne<16*ElvBigSprH.Taille-1   Then Begin ChgCouleur; MovCurColLig( 0, 1); End;

          ' '    : ChgCouleur;

          KeyCopy: If TstKey(Ctrl) Then Copier
                   Else If TstKey(Shift) Then Coller
                   Else  GetCouleur;

          KeyDel : If PopUpOK('Effacer le sprite?',38) Then
                     Rectangle(0,0,ElvBigSprH.Taille*16-1,ElvBigSprL.Taille*16-1,ElvPal.NumPal,True);
          #13    : If TstKey(21) Then SetZoomSpr(SprMarque,0) Else Marque;
          'd','D': TraceDroite;
          'r','R': Rectangle(Ligne,Colonne,LigM,ColM,ElvPal.NumPal,False);
          #18    : Rectangle(Ligne,Colonne,LigM,ColM,ElvPal.NumPal,True);
          's','S': Begin Dir:=Droite; EdtDtaPal; DspDtaVrb End;
          'q','Q': Begin Dir:=Gauche; EdtDtaPal; DspDtaVrb End;

          'f','F': If PopUpOK('Remplir la zone?',38) Then Begin
                     ProfRecursion:=0;
                     AncienneCouleur:=GetBigSprPxl(1,Ligne,Colonne);
                     NouvelleCouleur:=ElvPal.NumPal;
                     Fill(Ligne,Colonne);
                   End;

          'c','C': Cercle(Ligne,Colonne,ColM-Colonne,ElvPal.NumPal,False);
          #3     : Cercle(Ligne,Colonne,ColM-Colonne,ElvPal.NumPal,True);
          '1'    : AffReticuleDiag;
          '5'    : AffReticule;

          '2'    : If PopUpOK('D&placer de 1 pixel vers le bas?',60) Then DecaleBas;

          '8'    : If TstKey(Shift) Then Begin
                     If PopUpOK('Inverser haut-bas?',40) Then HautVersBas
                   End Else Begin
                      If PopUpOK('D&placer de 1 pixel vers le haut?',60) Then DecaleHaut;
                   End;

          '6'    : If PopUpOK('D&placer de 1 pixel @ droite?',60) Then DecaleDroite;

          '4'    : If TstKey(Shift) Then Begin
                     If PopUpOK('Inverser droite-gauche?',50) Then DroiteGauche;
                   End Else Begin
                     If PopUpOK('D&placer de 1 pixel @ gauche?',60) Then DecaleGauche;
                   End;

          KeyEsc : If TstKey(Ctrl) Then Begin
                    If PopUpOK('Annuler commande',40) Then ;
                   End;
        End;
      Until cc=KeyEsc;

      SetZoomSpr(SprCurseur,0);
    End;
