{ =================================================
   TP-TOOLS v1.0 pour Turbo Pascal/CPM+/CPC6128
   UGraph : Unite graphique v0.3 by Nemo59 (2021)
  ------------------------------------------------- }

Type TColor= { Palette du CPC }
             ( Noir, BleuFonce, Bleu, Marron, Violet, Mauve, Rouge, Pourpre,
               Magenta, VertFonce, Turquoise, BleuClair, Kaki, Gris, BleuPale,
               Orange, Rose, MagentaClair, Vert, VertMarin, Cyan, VertCitron,
               VertPale, CyanPale, Jaune, JaunePale, Blanc );

     TScrMod=(ForceMode,XorMode,AndMode,OrMode);

Const TagFlg : Boolean = False;
      TagAdr : Integer = 0;

Var BGraph:Byte; IGraph1,IGraph2:Integer;

Procedure SetTxtCur(X,Y:Byte);
 Begin InLine($3a/X/$67/$3a/Y/$6f/$cd/$fc5a/$bb75); End;

Procedure GetTxtCur(Var X,Y:Byte);
 Begin InLine($cd/$fc5a/$bb78/$7c/$32/X/$7d/$32/Y); End;

Procedure DspTxtCur;
 Begin InLine($cd/$fc5a/$bb7b); End;

Procedure HidTxtCur;
 Begin InLine($cd/$fc5a/$bb7e); End;

Procedure SetTxtPap(Paper:byte);
 Begin InLine($3a/Paper/$cd/$fc5a/$bb96); End;

Procedure SetTxtPen(Pen:byte);
 Begin InLine($3a/Pen/$cd/$fc5a/$bb90); End;

Procedure IniGra;
 Begin InLine($cd/$fc5a/$bbba);End;

Procedure SetMod(Mode:Byte);
 Begin InLine($3a/Mode/$cd/$fc5a/$bc0e); End;

Function EncInk(InkColor:TColor):Byte; { ENCode INK }
 Begin
  InLine($3a/InkColor/$cd/$fc5a/$bc2c/$32/BGraph);
  EncInk:=BGraph;
 End;

Procedure SetInk(Ink:Byte; C1,C2:TColor);
 Begin InLine($3a/C1/$47/$3a/C2/$4f/$3a/Ink/$cd/$fc5a/$bc32); End;

Procedure SetBdr(C1,C2:TColor); { SET BorDeR color }
 Begin InLine($3a/C1/$47/$3a/C2/$4f/$cd/$fc5a/$bc38); End;

Procedure DrwFldBox(EncodedInk:Byte; Adr:Integer; WidthBytes,Height:Byte);
 Begin
  InLine($3a/EncodedInk/$4f/$2A/Adr/$3a/WidthBytes/$57/$3a/Height/$5f/$cd/$fc5a/$bc47);
 End;

Procedure DrwHorLin(EncodedInk:Byte; XStart, Y, XEnd:Integer);
 Begin
  Inline($3a/EncodedInk/$ed/$5b/XStart/$ed/$4b/XEnd/$2a/Y/$cd/$fc5a/$bc5f);
 End;

Procedure DrwVerLin(EncodedInk:Byte; YStart, X, YEnd:Integer);
 Begin
  Inline($3a/EncodedInk/$ed/$5b/X/$ed/$4b/YEnd/$2a/YStart/$cd/$fc5a/$bc62);
 End;

Procedure DrwScrRec(Enc:Byte; x1,y1,x2,y2:Integer);
 Begin
  DrwHorLin(Enc,x1,x2,y1);
  DrwHorLin(Enc,x1,x2,y2);
  DrwVerLin(Enc,y1,y2,x1);
  DrwVerLin(Enc,y1,y2,x2);
 End;


Procedure GetPntAdr(X,Y:Integer; Var Addr:Integer; Var Mask:Byte);
 Begin
  InLine($ed/$5b/X/$2a/Y/$cd/$fc5a/$bc1d/$22/IGraph1/$79/$32/BGraph);
  Addr:=IGraph1; Mask:=BGraph;
 End;

Procedure MovAbs(x,y:Integer);
 Begin InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbc0) End;

Procedure MovRel(x,y:Integer);
 Begin InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbc3) End;

Procedure SetOrg(x,y:Integer); { SET ORiGin }
 Begin InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbc9) End;

Procedure SetWinWdt(x1,x2:Integer); { SET WINdows WiDTh }
 Begin inline($2a/x2/$eb/$2a/x1/$cd/$fc5a/$bbcf) End;

Procedure SetWinHht(y1,y2:Integer); {SET WINdows HeigHT }
 Begin InLine($2a/y2/$eb/$2a/y1/$cd/$fc5a/$bbd2) End;

Procedure DrwLinAbs(x,y:Integer);
 Begin InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbf6) End;

Procedure DrwLinRel(x,y:Integer);
 Begin InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbf9) End;

Procedure DrwRecRel(dx,dy:Integer);
 Begin
  DrwLinRel( dx,0); DrwLinRel(0, dy);
  DrwLinRel(-dx,0); DrwLinRel(0,-dy);
 End;

Procedure DrwPntAbs(x,y:Integer);
 Begin InLine($00/$ed/$ff/$2A/x/$eb/$2A/y/$cd/$fc5a/$bbea/$ed/$ff) End;

Procedure DrwPntRel(x,y:Integer);
 Begin InLine($2A/x/$eb/$2a/y/$cd/$fc5a/$bbed) End;

Function GetPntAbs(x,y:Integer):Byte;
 Begin
   InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbf0/$32/BGraph);
   GetPntAbs:=BGraph;
 End;

Function GetPntRel(x,y:Integer):Byte;
 Begin InLine($2a/x/$eb/$2a/y/$cd/$fc5a/$bbf3/$32/BGraph);
       GetPntRel:=BGraph;
 End;

Procedure SetGraPen(Pen:Byte);
 Begin InLine($3a/Pen/$cd/$fc5a/$bbde) End;

Procedure SetGraPap(Paper:Byte);
 Begin InLine($3A/Paper/$cd/$fc5a/$bbe4) End;

Procedure GetGraCur(Var X,Y:Integer);
 Begin
  InLine($cd/$fc5a/$bbc6/$22/IGraph2/$eb/$22/IGraph1);
  X:=IGraph1; Y:=IGraph2;
 End;

Procedure ClrGraWin;
 Begin InLine($cd/$fc5a/$bbdb) End;

Procedure DrwGraChr(Ch:char);
 Begin InLine($3a/Ch/$cd/$fc5a/$bbfc) End;

Procedure SetLinMsk(Mask:Byte);
 Begin InLine($3A/Mask/$cd/$fc5a/$bd4c) End;

Procedure SetPalMod1(c0,c1,c2,c3:TColor);
 Begin
  SetInk(0,c0,c0);SetInk(1,c1,c1);SetInk(2,c2,c2);SetInk(3,c3,c3);
 End;

Procedure SetTxtWin(c1,c2,l1,l2:Byte);
 Begin
  InLine($3a/c1/$67/$3a/c2/$57/$3a/l1/$6f/$3a/l2/$5f/$cd/$fc5a/$bb66);
 End;

Procedure GrafOut(ch:Char);
 Begin
   InLine($3a/ch/$cd/$fc5a/$bbfc);
 End;

Procedure SetTag;
 Begin
  If Not TagFlg Then Begin
   TagAdr:=ConOutPtr; TagFlg:=True; ConOutPtr:=Addr(GrafOut);
  End;
 End;

Procedure RmvTag;
 Begin
  If TagFlg Then Begin
    ConOutPtr:=TagAdr; TagFlg:=False;
  End;
 End;

Procedure SetWrtMod(m:TScrMod);
 Begin InLine($3a/m/$cd/$fc5a/$bc59) End;
